Attribute VB_Name = "dkmPGMs"
Option Explicit
Const CITATELINELENGTH = 64
Const TimeoutBeforeAddresSet = 13
Const TimeoutBeforeSend = 8
Const AssumedLang = -1 'for Check_Grammar
Const REFWprefix = ": "
Const EndBodyString = "-- "
Const doReplay = 1
Const doReplayAll = 2
Const ruGreeting = ", %name%."
Const enGreeting = "Hello, %name%."
Const ruStrings = "   [%subj%]  %date%,   :"
Const enStrings = "On your message [%subj%] of %date% I can say the next:"
Const ruDAYS = "      "
Const enDAYS = "Sun Mon Tu Wed Thu Fri Sat"
Const ContactFolderName = "" 'Folder for autosaved contacts
Const SavePrefixInField = "BillingInformation"
'If empty, use UserProperties.Item("AnsPrefix")
'Others string fields:
'BillingInformation, Categories, Companies, MessageClass, Mileage, VotingOptions, VotingResponse

Sub CheckGrammar()
Dim Letter As MailItem, LetterStrings, str2check, Prefix As String, LetterBody As String
Dim Word As Word.Application
Set Letter = ActiveInspector.CurrentItem
Prefix = ""
On Error Resume Next
If SavePrefixInField = "" Then
  Prefix = Letter.UserProperties.Item("AnsPrefix").Value
Else
  Prefix = Letter.ItemProperties.Item(SavePrefixInField).Value
End If
On Error GoTo 0
LetterStrings = Split(Letter.Body, vbCrLf)
LetterBody = ""
For Each str2check In LetterStrings
  str2check = Trim(str2check)
  If Not (Prefix <> "" And str2check <> "" And InStr(str2check, Prefix) = 1) Then  'check this string
    If (Word Is Nothing) Then
      On Error Resume Next
      Set Word = New Word.Application
      On Error GoTo 0
    End If
    If Not (Word Is Nothing) Then
      str2check = Check_Grammar(str2check, Word) & vbCrLf
    Else
      Exit For
    End If
  End If
  LetterBody = LetterBody & str2check & vbCrLf
Next
If Not (Word Is Nothing) Then
  Letter.Body = LetterBody
  Word.Quit False
Else
  MsgBox "not Checked:" & vbCrLf & "no MS Word in Your system"
End If
Letter.Display
End Sub

Function Check_Grammar(ByVal text2check As String, MsWord As Word.Application) As String
Dim ChDoc As Word.document, TextAfterCheck As String
MsWord.Visible = True
Set ChDoc = MsWord.Documents.Add
ChDoc.Range.text = text2check
If AssumedLang < 0 Then
  ChDoc.DetectLanguage
Else
  ChDoc.Range.LanguageID = AssumedLang
End If 'AssumedLang
ChDoc.CheckGrammar
TextAfterCheck = MsWord.CleanString(ChDoc.Range.text)
ChDoc.Close False
Check_Grammar = TextAfterCheck
End Function
Sub dkmReplay(Letter As MailItem, WhatToDo As Long)
Dim Sendername As String, LetterStrings, singleLine
Dim Answer As MailItem, AnswerStrings, AnswerBody, Prefix, AnswerOption
Dim Shell As WshShell, ScriptName As String
Dim SetAddressingPermissionsProcess As WshExec, prLog As String
Dim Greeting, Strings, lng As Long
Err.Clear
Greeting = Array(ruGreeting, enGreeting)
Strings = Array(ruStrings, enStrings)
lng = 1 'english
If (Letter.Subject & Letter.Body) Like "*[]*" Then
  lng = 0 'russian
End If
AnswerOption = Letter.Actions.Item(1).ReplyStyle
Letter.Actions.Item(1).ReplyStyle = olOmitOriginalText
Select Case WhatToDo
  Case doReplay: Set Answer = Letter.Reply
  Case doReplayAll: Set Answer = Letter.ReplyAll
  Case Else
    MsgBox "Wrong Call of dkmReplay procedure", vbCritical + vbSystemModal
    Exit Sub
End Select
Set Shell = New WshShell
ScriptName = SetAddressingPermissionsScript
'Debug.Print ScriptName
Set SetAddressingPermissionsProcess = Shell.Exec("wscript.exe """ + ScriptName + """")
On Error Resume Next
Sendername = Letter.SentOnBehalfOfName 'Sendername
If Sendername = "" Then
  SetAddressingPermissionsProcess.Terminate
  Set SetAddressingPermissionsProcess = Nothing
  Set SetAddressingPermissionsProcess = Shell.Exec("wscript.exe """ + ScriptName + """")
  Sendername = Letter.Sendername 'SentOnBehalfOfName
End If
If Err.Number <> 0 Then
'Debug.Print Err.Number, Err.Description
MsgBox "Try once more!!", vbCritical + vbOKOnly, "Obstinate Outlook"
End If
SetAddressingPermissionsProcess.Terminate
Set SetAddressingPermissionsProcess = Nothing
Letter.Actions.Item(1).ReplyStyle = AnswerOption
Prefix = FIO(Sendername) & "> "
If SavePrefixInField = "" Then
  Answer.UserProperties.Add "AnsPrefix", olText
  Answer.UserProperties.Item("AnsPrefix").Value = Prefix
Else
  Answer.ItemProperties.Item(SavePrefixInField).Value = Prefix
End If
Answer.BodyFormat = olFormatPlain
Answer.Body = Replace(Greeting(lng), "%name%", Sendername) & vbCrLf & vbCrLf
Answer.Body = Answer.Body & _
  Replace( _
  Replace( _
  Strings(lng), "%date%", dkmDateFormat(Letter.ReceivedTime, lng)), _
  "%subj%", Trim(Mid(Letter.Subject, InStr(Letter.Subject, REFWprefix) + 1))) _
  & vbCrLf & vbCrLf
AnswerBody = Letter.Body
AnswerStrings = Split(AnswerBody, vbCrLf)
AnswerBody = ""
On Error GoTo Saved
Dim oCont As ContactItem
Dim cName As String, cAddr As String, cFolder As MAPIFolder, cItem As ContactItem
cName = Answer.Recipients.Item(1).Name
cAddr = Answer.Recipients.Item(1).Address
'Find folder
For Each cFolder In Application.GetNamespace("MAPI").GetDefaultFolder(olFolderContacts).Folders
    If UCase(cFolder.Name) = UCase(ContactFolderName) Then
        'folder is founded then find contact
        For Each cItem In cFolder.Items
            If UCase(Trim(cItem.FullName)) = UCase(Trim(cName)) Then GoTo Saved 'no duplicate
        Next
        Set oCont = cFolder.Items.Add(olContactItem)
        oCont.FullName = cName
        oCont.Email1Address = cAddr
        Debug.Print cName, cAddr
        oCont.Save
        Exit For
    End If
Next
Saved: 'or not
Dim prevBlank: prevBlank = False
For Each singleLine In AnswerStrings
  If singleLine = EndBodyString Then Exit For
  If Not (prevBlank And singleLine = "") Then
    prevBlank = (singleLine = "")
    Answer.Body = Answer.Body & Prefix & singleLine & vbCrLf
  End If
Next
Answer.Display
Shell.SendKeys "^{HOME}{DEL 2}"
On Error Resume Next
Kill ScriptName
End Sub

Function FIO(ByVal s As String) As String
Dim retval, wrd, ch
For Each ch In Array("@", ".", "-", "(", ")", "[", "]", "{", "}")
  s = Replace(s, ch, " ")
Next
retval = ""
For Each wrd In Split(s)
  retval = retval & Left(wrd, 1)
Next
If Len(retval) = 1 Then retval = Left(s, 3)
FIO = Left(retval, 3)
End Function

Function dkmDateFormat(d As Date, lng As Long) As String
Dim DAYS
DAYS = Array(ruDAYS, enDAYS)
If lng < 0 Or lng > 1 Then lng = 0
dkmDateFormat = _
  Split(DAYS(lng))(DatePart("w", d) - 1) & ", " & _
  Format(d, "dd.mm.yyyy") & "(" & _
  Format(d, "HH:MM") & ")"
End Function

Function SetAddressingPermissionsScript() As String
Dim FileName, fs As New FileSystemObject, script As TextStream
Do
  FileName = fs.BuildPath(Environ("TEMP"), fs.GetTempName & ".vbs")
Loop Until Not fs.FileExists(FileName)
FileName = fs.GetAbsolutePathName(FileName)
Set script = fs.CreateTextFile(FileName, True, False)
script.WriteLine "set WshShell=WScript.CreateObject(""WScript.Shell"")"
'script.WriteLine "activated = False"
'script.WriteLine "Time2wait = " & CStr(1000 * TimeoutBeforeAddresSet)
script.WriteLine "dt = 101: activated = False: Time2wait = " & CStr(1000 * TimeoutBeforeAddresSet)
script.WriteLine "Do While (Not activated And Time2wait > 0)"
script.WriteLine "  activated = WshShell.AppActivate(""Microsoft Outlook"")"
script.WriteLine "  WScript.Sleep (dt): Time2wait = Time2wait - dt"
'script.WriteLine "  Time2wait = Time2wait - dt"
script.WriteLine "Loop"
script.WriteLine "If Time2Wait >= 0 Then"
script.WriteLine "  WScript.Sleep(100): WshShell.SendKeys(""{TAB 2} {TAB 2}{ENTER}"")"
'script.WriteLine "  WshShell.SendKeys(""{TAB 2} {TAB 2}{ENTER}"")"
script.WriteLine "Else"
script.WriteLine "  Call WshShell.Popup(""Safety Window not found!!!"",600,""Error"",48)"
script.WriteLine "End If"
script.Close
SetAddressingPermissionsScript = FileName
End Function 'SetAddressingPermissions

Sub RedefineButtonsInExplorer() '   
Dim bar As CommandBar
Const ReplayButtonIndex = 6
Const ReplayAllButtonIndex = 7
Set bar = ActiveExplorer.CommandBars("standard")
If MsgBox("Change action for button '" & Replace(bar.Controls(ReplayButtonIndex).Caption, "&", "") & "' to 'dkmReplayE'?", vbQuestion + vbYesNo) = vbYes Then
  ActiveExplorer.CommandBars("standard").Controls(ReplayButtonIndex).OnAction = "dkmReplayE"
End If
If MsgBox("Change action for button '" & Replace(bar.Controls(ReplayAllButtonIndex).Caption, "&", "") & "' to 'dkmReplayAllE'?", vbQuestion + vbYesNo) = vbYes Then
  ActiveExplorer.CommandBars("standard").Controls(ReplayAllButtonIndex).OnAction = "dkmReplayAllE"
End If
End Sub

Sub dkmReplayI()
Dim Item As Object
Set Item = ActiveInspector.CurrentItem
If Item.Class = olMail Then
  dkmReplay Item, doReplay
Else
  MsgBox "This procedure for eMail Only !!!", vbCritical + vbSystemModal, "Wrong Item Type"
End If
End Sub

Sub dkmReplayAllI()
Dim Item As Object
Set Item = ActiveInspector.CurrentItem
If Item.Class = olMail Then
  dkmReplay Item, doReplayAll
Else
  MsgBox "This procedure for eMail Only !!!", vbCritical + vbSystemModal, "Wrong Item Type"
End If
End Sub

Sub dkmReplayE()
Dim Item As Object, Letter As Object
If ActiveExplorer.Selection.Count > 0 Then
  Set Item = ActiveExplorer.Selection.Item(1)
Else
  MsgBox "Select any eMail first !!!", vbInformation, "Smart Replay"
  Exit Sub
End If
If Item.Class = olMail Then
  dkmReplay Item, doReplay
Else
  MsgBox "This procedure for eMail Only !!!", vbCritical + vbSystemModal, "Wrong Item Type"
End If
End Sub

Sub dkmReplayAllE()
Dim Item As Object, Letter As Object
If ActiveExplorer.Selection.Count > 0 Then
  Set Item = ActiveExplorer.Selection.Item(1)
Else
  MsgBox "Select any eMail first !!!", vbInformation, "Smart Replay"
  Exit Sub
End If
If Item.Class = olMail Then
  dkmReplay Item, doReplayAll
Else
  MsgBox "This procedure for eMail Only !!!", vbCritical + vbSystemModal, "Wrong Item Type"
End If
End Sub

